// This file is part of Notepad++ project
// Copyright (C)2021 Don HO <don.h@free.fr>

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// at your option any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.



// LastRecentFileListͷļ  
#include "lastRecentFileList.h"  
// ˵IDͷļ  
#include "menuCmdID.h"  
// 뱾ػͷļֶ֧  
#include "localization.h"  

// LastRecentFileListinitMenu  
void LastRecentFileList::initMenu(HMENU hMenu, int idBase, int posBase, Accelerator* pAccelerator, bool doSubMenu)
{
    // doSubMenuΪ棬ʾҪһ˵  
    if (doSubMenu)
    {
        // ø˵  
        _hParentMenu = hMenu;
        // һµĵ˵  
        _hMenu = ::CreatePopupMenu();
    }
    // doSubMenuΪ٣ʾֱʹôĲ˵  
    else
    {
        // ø˵ΪNULLʾ˵  
        _hParentMenu = NULL;
        // ʹôĲ˵Ϊǰ˵  
        _hMenu = hMenu;
    }

    // IDĻֵ  
    _idBase = idBase;
    // λõĻֵ  
    _posBase = posBase;
    // ָAcceleratorָ룬ڴ̿ݼȼٹ  
    _pAccelerator = pAccelerator;
    // ñػԱΪWindows1252룬һŷԱ  
    _nativeLangEncoding = NPP_CP_WIN_1252;

    // ʼidFreeArray飬ԪضΪtrueʾID  
    for (size_t i = 0; i < sizeof(_idFreeArray); ++i)
        _idFreeArray[i] = true;
}

// LastRecentFileListswitchModeлģʽ  
void LastRecentFileList::switchMode()
{
    // Ӳ˵Ƴز˵  
    ::RemoveMenu(_hMenu, IDM_FILE_RESTORELASTCLOSEDFILE, MF_BYCOMMAND);
    ::RemoveMenu(_hMenu, IDM_OPEN_ALL_RECENT_FILE, MF_BYCOMMAND);
    ::RemoveMenu(_hMenu, IDM_CLEAN_RECENT_FILE_LIST, MF_BYCOMMAND);

    // ļбƳв˵  
    for (int i = 0; i < _size; ++i)
    {
        ::RemoveMenu(_hMenu, _lrfl.at(i)._id, MF_BYCOMMAND);
    }

    // _hParentMenuֵжϵǰģʽ˵ģʽӲ˵ģʽ  
    if (_hParentMenu == NULL) // mode main menu˵ģʽ  
    {
        if (_size > 0) // ļбΪ  
        {
            // ˵ƳһЩضĲ˵ƳЩδ  
            ::RemoveMenu(_hMenu, _posBase, MF_BYPOSITION);
            ::RemoveMenu(_hMenu, _posBase, MF_BYPOSITION);
        }
        // лӲ˵ģʽһµĵ˵Ϊǰ˵_hParentMenuΪǰ˵´ĵ˵  
        // ͬʱƳһЩضĲ˵ƳЩδ  
        _hParentMenu = _hMenu;
        _hMenu = ::CreatePopupMenu();
        ::RemoveMenu(_hMenu, _posBase + 1, MF_BYPOSITION);
    }
    else // mode sub-menuӲ˵ģʽ  
    {
        if (_size > 0) // ļбΪ  
        {
            // Ӳ˵ƳһЩضĲ˵ƳЩδ  
            ::RemoveMenu(_hParentMenu, _posBase, MF_BYPOSITION);
            ::RemoveMenu(_hParentMenu, _posBase, MF_BYPOSITION);
        }
        // switch to main menu mode
        ::DestroyMenu(_hMenu);
        _hMenu = _hParentMenu;
        _hParentMenu = NULL;
    }
    _hasSeparators = false;
}

void LastRecentFileList::updateMenu()
{
    // ȡ NppParameters ĵʵ  
    NppParameters& nppParam = NppParameters::getInstance();

    // ǷûзָҴС0 if   
    if (!_hasSeparators && _size > 0)
    {
        // ȡػԵķ˶  
        NativeLangSpeaker* pNativeLangSpeaker = nppParam.getNativeLangSpeaker();

        // ӷ˶лȡһЩػ˵ַ  
        generic_string recentFileList = pNativeLangSpeaker->getSubMenuEntryName("file-recentFiles");
        generic_string openRecentClosedFile = pNativeLangSpeaker->getNativeLangMenuString(IDM_FILE_RESTORELASTCLOSEDFILE);
        generic_string openAllFiles = pNativeLangSpeaker->getNativeLangMenuString(IDM_OPEN_ALL_RECENT_FILE);
        generic_string cleanFileList = pNativeLangSpeaker->getNativeLangMenuString(IDM_CLEAN_RECENT_FILE_LIST);

        // ȡַΪգʹĬϵַгʼ  
        if (recentFileList == TEXT(""))
            recentFileList = TEXT("&Recent Files");
        if (openRecentClosedFile == TEXT(""))
            openRecentClosedFile = TEXT("Restore Recent Closed File");
        if (openAllFiles == TEXT(""))
            openAllFiles = TEXT("Open All Recent Files");
        if (cleanFileList == TEXT(""))
            cleanFileList = TEXT("Empty Recent Files List");

        // ǰӲ˵ģʽڲ˵вһָ  
        if (!isSubMenuMode())
            ::InsertMenu(_hMenu, _posBase + 0, MF_BYPOSITION, static_cast<UINT_PTR>(-1), 0);

        // ڲ˵вĸӲ˵ֱǻָرյļļļбһָ  
        ::InsertMenu(_hMenu, _posBase + 1, MF_BYPOSITION, IDM_FILE_RESTORELASTCLOSEDFILE, openRecentClosedFile.c_str());
        ::InsertMenu(_hMenu, _posBase + 2, MF_BYPOSITION, IDM_OPEN_ALL_RECENT_FILE, openAllFiles.c_str());
        ::InsertMenu(_hMenu, _posBase + 3, MF_BYPOSITION, IDM_CLEAN_RECENT_FILE_LIST, cleanFileList.c_str());
        ::InsertMenu(_hMenu, _posBase + 4, MF_BYPOSITION, static_cast<UINT_PTR>(-1), 0); // ָ  
        // ñ־ʾзָ  
        _hasSeparators = true;

        // ǰӲ˵ģʽڸ˵вӲ˵ͷָ  
        if (isSubMenuMode())
        {
            ::InsertMenu(_hParentMenu, _posBase + 0, MF_BYPOSITION | MF_POPUP, reinterpret_cast<UINT_PTR>(_hMenu), (LPCTSTR)recentFileList.c_str());
            ::InsertMenu(_hParentMenu, _posBase + 1, MF_BYPOSITION, static_cast<UINT_PTR>(-1), 0); // ָ  
        }
    }
    else if (_hasSeparators && _size == 0)  // зָҴСΪ0ʱ if 飬ƳָͲ˵  
    {
        // Ӳ˵ƳһָļбĲ˵  
        ::RemoveMenu(_hMenu, _posBase + 4, MF_BYPOSITION);
        ::RemoveMenu(_hMenu, IDM_CLEAN_RECENT_FILE_LIST, MF_BYCOMMAND);
        ::RemoveMenu(_hMenu, IDM_OPEN_ALL_RECENT_FILE, MF_BYCOMMAND);
        ::RemoveMenu(_hMenu, IDM_FILE_RESTORELASTCLOSEDFILE, MF_BYCOMMAND);
        ::RemoveMenu(_hMenu, _posBase + 0, MF_BYPOSITION);
        _hasSeparators = false;

        if (isSubMenuMode())
        {
            // Remove "Recent Files" Entry and the separator from the main menu
            ::RemoveMenu(_hParentMenu, _posBase + 1, MF_BYPOSITION);
            ::RemoveMenu(_hParentMenu, _posBase + 0, MF_BYPOSITION);

            // Remove the last left separator from the submenu
            ::RemoveMenu(_hMenu, 0, MF_BYPOSITION);
        }
    }

    _pAccelerator->updateFullMenu();

    //Remove all menu items
    for (int i = 0; i < _size; ++i)
    {
        ::RemoveMenu(_hMenu, _lrfl.at(i)._id, MF_BYCOMMAND);
    }
    //Then readd them, so everything stays in sync
    for (int j = 0; j < _size; ++j)
    {
        generic_string strBuffer(BuildMenuFileName(nppParam.getRecentFileCustomLength(), j, _lrfl.at(j)._name));
        ::InsertMenu(_hMenu, _posBase + j, MF_BYPOSITION, _lrfl.at(j)._id, strBuffer.c_str());
    }

}
// ļбһļﵽûƻб򲻻ӡ  
// ļѴڣȽƳӡ  
void LastRecentFileList::add(const TCHAR* fn)
{
    if (_userMax == 0 || _locked) // ûΪ0бֱӷأ  
        return;

    RecentItem itemToAdd(fn); // һµRecentItemʹôļʼ  

    int index = find(fn); // Ҹļбе  
    if (index != -1) // ҵ  
    {
        // ļѴڣȽƳȻ  
        remove(index);
    }

    if (_size == _userMax) // б  
    {
        itemToAdd._id = _lrfl.back()._id; // ʹһԪصIDʼԪصID  
        _lrfl.pop_back(); // ƳбеһԪأɵһ  
    }
    else // бδ  
    {
        itemToAdd._id = popFirstAvailableID(); // ȡһõIDʼԪصID  
        ++_size; // бĴС  
    }
    _lrfl.push_front(itemToAdd); // бǰԪ  
    updateMenu(); // ²˵  
}

// ļļбƳһļҵƳʲôҲ  
void LastRecentFileList::remove(const TCHAR* fn)
{
    int index = find(fn); // ļбе  
    if (index != -1) // ҵ  
        remove(index); // ƳԪ  
}

// ļбƳһļЧƳʲôҲ  
void LastRecentFileList::remove(size_t index)
{
    if (_size == 0 || _locked) // бΪջֱӷأƳ  
        return;
    if (index < _lrfl.size()) // Ч  
    {
        ::RemoveMenu(_hMenu, _lrfl.at(index)._id, MF_BYCOMMAND); // Ӳ˵ƳIDӦĲ˵  
        setAvailable(_lrfl.at(index)._id); // IDΪãΪ´ʱظʹã  
        _lrfl.erase(_lrfl.begin() + index); // бƳԪ  
        --_size; // бĴС  
        updateMenu(); // ²˵  
    }
}

// ļбļIDᱻƳ˵ҲӦظ¡  
void LastRecentFileList::clear()
{
    if (_size == 0) // бΪգֱӷأκβ  
        return;
    for (int i = (_size - 1); i >= 0; i--) // ӺǰбΪƳԪػӰԪص  
    {
        ::RemoveMenu(_hMenu, _lrfl.at(i)._id, MF_BYCOMMAND); // Ӳ˵ƳIDӦĲ˵  
        setAvailable(_lrfl.at(i)._id); // IDΪãΪ´ʱظʹã  
        _lrfl.erase(_lrfl.begin() + i); // бƳԪ  
    }
    _size = 0; // бСΪ0  
    updateMenu(); // ²˵  
}

δ붨һΪLastRecentFileList࣬ڹ򿪵ļбϸעͣ

cpp
// IDļблȡһļҵ򷵻ضӦļ򷵻беĵһļ  
generic_string& LastRecentFileList::getItem(int id)
{
    int i = 0; // 0ʼңΪIDڣܻ᷵صһļΪĬֵ  
    for (; i < _size; ++i) // бƥIDҲi_sizeʱiᱻΪ0һ󱸼ƻԷIDб  
    {
        if (_lrfl.at(i)._id == id) // ҵƥID  
            break;
    }
    if (i == _size) // бûҵƥID  
        i = 0; // Ϊ0ԴбĵһԪؿʼļΪĬֵ  
    return _lrfl.at(i)._name; // ҵļĬļ  
}

// ļблȡһļЧ򷵻ضӦļ򷵻беĵһļ  
generic_string& LastRecentFileList::getIndex(int index)
{
    return _lrfl.at(index)._name; // ҵļĬļ  
}

// ûļбСǰбСõĴСƳɵļֱбСõĴС  
void LastRecentFileList::setUserMaxNbLRF(int size)
{
    _userMax = size; // ûбС  
    if (_size > _userMax) // ǰбСõĴС  
    {
        int toPop = _size - _userMax; // ҪƳļ  
        while (toPop > 0) // ļҪƳʱ  
        {
            ::RemoveMenu(_hMenu, _lrfl.back()._id, MF_BYCOMMAND); // Ӳ˵ƳIDӦĲ˵  
            setAvailable(_lrfl.back()._id); // IDΪãΪ´ʱظʹã  
            _lrfl.pop_back(); // бƳԪ  
            toPop--; // ʣҪƳļ  
            _size--; // ٵǰбС  
        }
        updateMenu(); // ²˵  
        _size = _userMax; // ǰбСΪõĴС  
    }
}

// ļб浽ļСļ˳ʱͬ  
void LastRecentFileList::saveLRFL()
{
    NppParameters& nppParams = NppParameters::getInstance(); // ȡNppParametersʵ  
    if (nppParams.writeRecentFileHistorySettings(_userMax)) // ɹдļʷ  
    {
        for (int i = _size - 1; i >= 0; i--) // մӺǰ˳򱣴ļȷʱ˳ȷ  
        {
            nppParams.writeHistory(_lrfl.at(i)._name.c_str()); // ļдļʷ¼  
        }
    }
}




// ļбвָļ  
int LastRecentFileList::find(const TCHAR* fn)
{
    for (int i = 0; i < _size; ++i) // б  
    {
        if (OrdinalIgnoreCaseCompareStrings(_lrfl.at(i)._name.c_str(), fn) == 0) // ҵƥļԴСд  
        {
            return i; // ظļбе  
        }
    }
    return -1; // δҵ-1  
}

// һõID  
int LastRecentFileList::popFirstAvailableID()
{
    for (int i = 0; i < NB_MAX_LRF_FILE; ++i) // пܵID  
    {
        if (_idFreeArray[i]) // IDãδʹã  
        {
            _idFreeArray[i] = false; // ǸIDΪʹ  
            return i + _idBase; // ظIDֵ_idBaseʼ㣩  
        }
    }
    return 0; // IDʹã0Ĭֵ  
}

// ָIDΪá  
void LastRecentFileList::setAvailable(int id)
{
    int index = id - _idBase; // ID_idFreeArrayе  
    _idFreeArray[index] = true; // ӦֵΪtrueʾID  
}
